
	processor 6502
	include vcs.h
	include macro.h

;---Constants Below-------------------------------


;---COLOR CONSTANTS-------------------------------

SKYBLUE		=	$8A
GRASSGREEN	=	$B8
BLACK		=	$00
WHITE		=	$0E
DARKGRAY	=	$04
MIDDARKGRAY	=	$06
MIDLIGHTGRAY	=	$08
LIGHTGRAY	=	$0A
BRIGHTYELLOW	=	$1E
FORESTGREEN	=	$B2
RED		=	$34
DARKRED		=	$42
DARKBLUE	=	$84
ORANGE		=	$3A
BROWN		=	$E4
PURPLE		=	$48
DARKBROWN	=	$F2
LIGHTBROWN	=	$F6
LIGHTLIGHTBROWN	=	$FE




ONECOPYNORMAL	=	0
TWOCOPYCLOSE	=	1
THREECOPYCLOSE	=	3
ONECOPYDOUBLE	=	5
THREECOPYMED	=	6
ONECOPYQUAD	=	7

;---End Constants-----------------------------------

;---Macros

	MAC FILLER
		REPEAT {1}
		.byte {2}
		REPEND
	ENDM
	


;--------Variables To Follow-------------

	SEG.U Variables
   	org $80

StackPtrLo ds 1
StackPtrHi ds 1
TextPointer ds 2
MiscPtr1 ds 2
MiscPtr2 ds 2

InstructionPointer ds 2

SelectedGame ds 1

InstructionLine ds 1

Temp1 ds 1
Temp2 ds 1
Temp3 ds 1

SELECTPressed ds 1
JoystickMoved ds 1


;---End Variables------------------------
	
	SEG Bank0
	org $F800

CharacterSetData
_
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000

A
        .byte #%10100000
        .byte #%10100000
        .byte #%11100000
        .byte #%10100000
        .byte #%01000000

B
        .byte #%11000000
        .byte #%10100000
        .byte #%11000000
        .byte #%10100000
        .byte #%11000000

C
        .byte #%01000000
        .byte #%10100000
        .byte #%10000000
        .byte #%10100000
        .byte #%01000000

D
        .byte #%11000000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%11000000

E
        .byte #%11100000
        .byte #%10000000
        .byte #%11000000
        .byte #%10000000
        .byte #%11100000

F
        .byte #%10000000
        .byte #%10000000
        .byte #%11000000
        .byte #%10000000
        .byte #%11100000

G
        .byte #%01100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10000000
        .byte #%01100000

H
        .byte #%10100000
        .byte #%10100000
        .byte #%11100000
        .byte #%10100000
        .byte #%10100000

I
        .byte #%11100000
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000
        .byte #%11100000

J
        .byte #%01000000
        .byte #%10100000
        .byte #%00100000
        .byte #%00100000
        .byte #%00100000


K
        .byte #%10100000
        .byte #%10100000
        .byte #%11000000
        .byte #%10100000
        .byte #%10100000

L
        .byte #%11100000
        .byte #%10000000
        .byte #%10000000
        .byte #%10000000
        .byte #%10000000

M
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%11100000
        .byte #%10100000

N
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%11100000

O
0
        .byte #%01000000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%01000000

P
        .byte #%10000000
        .byte #%10000000
        .byte #%11000000
        .byte #%10100000
        .byte #%11000000

Q
        .byte #%01100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%01000000

R
        .byte #%10100000
        .byte #%10100000
        .byte #%11000000
        .byte #%10100000
        .byte #%11000000

S
        .byte #%11000000
        .byte #%00100000
        .byte #%01000000
        .byte #%10000000
        .byte #%01100000

T
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000
        .byte #%11100000

U
        .byte #%11100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000

V
        .byte #%01000000
        .byte #%01000000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000

W
        .byte #%10100000
        .byte #%11100000
        .byte #%10100000
        .byte #%10100000
        .byte #%10100000

XX
        .byte #%10100000
        .byte #%10100000
        .byte #%01000000
        .byte #%10100000
        .byte #%10100000

YY
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000
        .byte #%10100000
        .byte #%10100000

Z
        .byte #%11100000
        .byte #%10000000
        .byte #%01000000
        .byte #%00100000
        .byte #%11100000

minus
        .byte #%00000000
        .byte #%00000000
        .byte #%11100000
        .byte #%00000000
        .byte #%00000000

plus
        .byte #%00000000
        .byte #%01000000
        .byte #%11100000
        .byte #%01000000
        .byte #%00000000

equal
        .byte #%00000000
        .byte #%11100000
        .byte #%00000000
        .byte #%11100000
        .byte #%00000000

bang
        .byte #%01000000
        .byte #%00000000
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000


left_parens
        .byte #%01000000
        .byte #%10000000
        .byte #%10000000
        .byte #%10000000
        .byte #%01000000

right_parens
        .byte #%01000000
        .byte #%00100000
        .byte #%00100000
        .byte #%00100000
        .byte #%01000000

comma
        .byte #%10000000
        .byte #%01000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000

apostrophe
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%01000000
        .byte #%01000000

interrogative
        .byte #%01000000
        .byte #%00000000
        .byte #%01000000
        .byte #%00100000
        .byte #%11000000

colon
        .byte #%00000000
        .byte #%01000000
        .byte #%00000000
        .byte #%01000000
        .byte #%00000000


period
        .byte #%01000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000
        .byte #%00000000

One
        .byte #%11100000
        .byte #%01000000
        .byte #%01000000
        .byte #%11000000
        .byte #%01000000

Two
        .byte #%11100000
        .byte #%10000000
        .byte #%01000000
        .byte #%00100000
        .byte #%11000000

Three
        .byte #%11000000
        .byte #%00100000
        .byte #%01000000
        .byte #%00100000
        .byte #%11000000

Four
        .byte #%00100000
        .byte #%00100000
        .byte #%11100000
        .byte #%10100000
        .byte #%10000000

Five
        .byte #%11000000
        .byte #%00100000
        .byte #%11000000
        .byte #%10000000
        .byte #%11100000

Six
        .byte #%01000000
        .byte #%10100000
        .byte #%11000000
        .byte #%10000000
        .byte #%01100000

Seven
        .byte #%01000000
        .byte #%01000000
        .byte #%01000000
        .byte #%00100000
        .byte #%11100000

Eight
        .byte #%01000000
        .byte #%10100000
        .byte #%01000000
        .byte #%10100000
        .byte #%01000000

Nine
        .byte #%01000000
        .byte #%00100000
        .byte #%01100000
        .byte #%10100000
        .byte #%01000000

	;---end character set data

Start
	CLEAN_START

;--any initial setup
	lda #3
	sta NUSIZ0
	sta NUSIZ1		;three close copies
	sta VDELP0
	sta VDELP1		;VDELed
	sta SelectedGame

	dec SelectedGame	;this should be two

;-------------------------------------------------------------------------
;--------------GAME MAIN LOOP---------------------------------------------
;-------------------------------------------------------------------------

MainGameLoop

;-------------------------------------------------------------------------
;-------------------VBLANK Routine----------------------------------------
;-------------------------------------------------------------------------

VBLANKRoutine
	lda #%00001111
VSYNCLoop
	sta WSYNC
	sta VSYNC
	lsr
	bcs VSYNCLoop

	lda #43
	sta TIM64T

	;--select game with SELECT

	lda SWCHB
	lsr
	lsr				;get SELECT into carry
	bcs SelectNotPressed
	lda SELECTPressed
	bne NoRapidSELECTing
	inc SELECTPressed
	sta InstructionLine
	dec SelectedGame
	bpl DoneWithSelect
	lda #2
	sta SelectedGame
	bne DoneWithSelect
SelectNotPressed
	lda #0
	sta SELECTPressed
NoRapidSELECTing
DoneWithSelect

	;--scroll instructions with joystick (R == down, L == up)

	lda SWCHA
	sta Temp1
	and #%11110000
	cmp #%11110000
	bne ScrollRoutine
	lda #0
	sta JoystickMoved
ScrollRoutine
	lda JoystickMoved
	bne NoRapidScrolling

	ldy SelectedGame
	lda InstructionLength,Y
	cmp InstructionLine
	beq CantScrollInstructionsDown
	;--else, we can scroll down
	bit Temp1
	bmi NoScrollDown
	lda InstructionLine
	clc
	adc #12
	sta InstructionLine
	inc JoystickMoved
NoScrollDown
CantScrollInstructionsDown
	lda InstructionLine
	beq CantScrollInstructionsUp
	bit Temp1
	bvs NoScrollUp
	lda InstructionLine
	sec
	sbc #12
	sta InstructionLine
	lda #1
	sta JoystickMoved
NoScrollUp
CantScrollInstructionsUp
NoRapidScrolling


	;--setup instruction pointers

	ldy SelectedGame
	lda InstructionPointerLo,Y
	clc
	adc InstructionLine
	sta InstructionPointer
	lda InstructionPointerHi,Y
	adc #0
	sta InstructionPointer+1


	;--set player values and position



	lda #56
	ldx #0
	jsr PositionASpriteSubroutine
	lda #64
	inx
	jsr PositionASpriteSubroutine

	;--setup some pointers for the text routine
	lda #>CharacterSetData
	sta MiscPtr1+1			;set high pointer for text data
	sta MiscPtr2+1			;set high pointer for text data

	;--ready first line of text

	lda #>TitleData
	sta TextPointer+1
	lda #<Title1
	sta TextPointer
	jsr PushLineOfTextSubroutine

WaitForVblankEnd
	lda INTIM
	bne WaitForVblankEnd

	sta WSYNC
	sta VBLANK	;turn off VBLANK - it was turned on by overscan


;-------------------------------------------------------------------------
;----------------------Kernel Routine-------------------------------------
;-------------------------------------------------------------------------

KernelRoutine


	ldx #2
	jmp FirstTimeThroughWeStartHere
TitleDisplayOuterLoop
	sta WSYNC
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0
	sta WSYNC
	sta COLUBK
	lda TitlePtrLo,X
	sta TextPointer
	jsr PushLineOfTextSubroutine
FirstTimeThroughWeStartHere
	sta WSYNC
	cpx SelectedGame
	bne WhiteTitleOnBlackBackground
	;--else black title on white blackground
	lda #BLACK
	sta COLUP0
	sta COLUP1
	lda #WHITE
	sta COLUBK
	bne DoneSettingTitleColors
WhiteTitleOnBlackBackground
	lda #WHITE
	sta COLUP0
	sta COLUP1
	lda #0
	sta COLUBK
DoneSettingTitleColors
	ldy #5
	stx Temp2
TitleDisplayInnerLoop
	sta WSYNC
	pla
	sta GRP0	;+7	 7
	pla
	sta GRP1	;+7	14
	pla
	sta GRP0	;+7	21
	sty Temp1	;+3	24

	pla
	tay		;+6	30
	pla
	tax		;+6	36
	pla		;+4	40

	sty.w GRP1	;+4	44
	stx GRP0	;+3	47
	sta GRP1	;+3	50
	sta GRP0	;+3	53

	ldy Temp1
	dey
	bne TitleDisplayInnerLoop
	ldx Temp2
	dex
	bpl TitleDisplayOuterLoop

	sta WSYNC
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0

	sta WSYNC
	sta COLUBK
	lda #WHITE
	sta COLUP0
	sta COLUP1

	sta WSYNC
	sta COLUBK
	
	ldx #3
InstructionDisplayOuterLoop
	sta WSYNC
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0
	lda InstructionPointer
	clc
	adc OffsetTable,X
	sta TextPointer
	lda InstructionPointer+1
	adc #0
	sta TextPointer+1
	jsr PushLineOfTextSubroutine
	sta WSYNC
	lda #0
	sta COLUBK
	ldy #5
	stx Temp2
InsructionDisplayInnerLoop
	sta WSYNC
	pla
	sta GRP0	;+7	 7
	pla
	sta GRP1	;+7	14
	pla
	sta GRP0	;+7	21
	sty Temp1	;+3	24

	pla
	tay		;+6	30
	pla
	tax		;+6	36
	pla		;+4	40

	sty.w GRP1	;+4	44
	stx GRP0	;+3	47
	sta GRP1	;+3	50
	sta GRP0	;+3	53

	ldy Temp1
	dey
	bne InsructionDisplayInnerLoop
	ldx Temp2
	dex
	bpl InstructionDisplayOuterLoop

	sta WSYNC
	lda #0
	sta GRP0
	sta GRP1
	sta GRP0

;-------------------------------------------------------------------------
;------------------------Overscan Routine---------------------------------
;-------------------------------------------------------------------------

OverscanRoutine




	lda #2
	sta WSYNC
	sta VBLANK	;turn on VBLANK
	lda  #23
	sta  TIM64T



WaitForOverscanEnd
	lda INTIM
	bne WaitForOverscanEnd
	
	jmp MainGameLoop

;-------------------------------------------------------------------------
;----------------------------End Main Routines----------------------------
;-------------------------------------------------------------------------


;*************************************************************************

;-------------------------------------------------------------------------
;----------------------Begin Subroutines----------------------------------
;-------------------------------------------------------------------------


PushLineOfTextSubroutine
	pla
	sta StackPtrHi
	pla
	sta StackPtrLo			;save stack pointer

	lda #0
	sta Temp1
GetTextDataOuterLoop
	ldy #11
GetTextDataInnerLoop
	lda (TextPointer),Y
	sta MiscPtr2
	dey
	lda (TextPointer),Y
	sta MiscPtr1
	sty Temp3			;save Y
	ldy Temp1
	lda (MiscPtr1),Y
	sta Temp2
	lda (MiscPtr2),Y
	lsr
	lsr
	lsr
	lsr
	ora Temp2
	pha				;push line of char data
	ldy Temp3			;restore Y
	dey
	bpl GetTextDataInnerLoop
	inc Temp1
	lda Temp1
	cmp #5
	bne GetTextDataOuterLoop

	lda StackPtrLo
	pha
	lda StackPtrHi
	pha				;restore stack pointer

	rts

;-------------------------------------------------------------------------


PositionASpriteSubroutine       ;call this function with A == horizontal position (0-159)
                                ;and X == the object to be positioned (0=P0, 1=P1, 2=M0, etc.)
                                ;if you do not wish to write to P1 during this function, make
                                ;sure Y==0 before you call it.  This function will change A but
				;will not change X or Y or any zero page RAM.
                                ;Call this function with at least 18 cycles left in the scanline
                                ;(jsr + lsr HMCLR + sty GRP0 + sta WSYNC = 18); it will return 9 cycles
                                ;into the second scanline

        sta HMCLR
	sec
        sta WSYNC                    ;begin line 1
DivideLoop
	sbc #15
	bcs DivideLoop			;+4/5	 4/ 9.../54

	eor #7				;+2	 6/11.../56
	asl
	asl
	asl
	asl				;+8	14/19.../64

	sta.wx HMP0,X			;+5	19/24.../69
        sta RESP0,X     		;+4     23/28/33/38/43/48/53/58/63/68/73
        sta WSYNC      			;+3      0      begin line 2
        sta HMOVE       		;+3
Ret
        rts             ;+6      9



;*************************************************************************

;-------------------------------------------------------------------------
;-------------------------Data Below--------------------------------------
;-------------------------------------------------------------------------

	;--note: all three titles must be on the same page.
TitleData

Title1
	.byte _,_,_,_
	.byte G,A,M,E
	.byte _,One,_,_
Title2
	.byte _,_,_,_,G,A,M,E,_,Two,_,_
Title3
	.byte _,_,_,_,G,A,M,E,_,Three,_,_

OffsetTable
	.byte 36,24,12,0

InstructionPointerLo
	.byte <Instruction3,<Instruction2,<Instruction1
InstructionPointerHi
	.byte >Instruction3,>Instruction2,>Instruction1

InstructionLength
	.byte 24,24,60

TitlePtrLo
	.byte <Title3,<Title2,<Title1

	;--note: instructions can cross page boundaries
Instruction1
	.byte D,E,M,O,_,M,E,N,U,_,plus,_
	.byte I,N,S,T,R,U,C,T,I,O,N,S
	.byte S,E,L,E,C,T,_,T,O,_,_,_
	.byte C,H,O,O,S,E,_,G,A,M,E,_
	.byte _,_,_,_,_,_,_,_,_,_,_,_
	.byte C,O,D,E,D,_,B,YY,_,B,O,B
	.byte M,O,N,T,G,O,M,E,R,YY,_,_
	.byte C,O,P,YY,R,I,G,H,T,_,_,_
	.byte Two,O,O,Five,_,_,_,_,_,_,_,_
Instruction2
	.byte L,E,F,T,_,T,O,_,_,_,_,_
	.byte S,C,R,O,L,L,_,U,P,comma,_,_
	.byte R,I,G,H,T,_,T,O,_,_,_,_
	.byte S,C,R,O,L,L,_,D,O,W,N,period
	.byte M,O,R,E,_,T,E,XX,T,_,_,_
	.byte B,E,L,O,W,bang,_,_,_,_,_,_

Instruction3
	.byte S,A,M,P,L,E,_,T,E,XX,T,colon
	.byte A,B,C,D,E,F,G,H,I,J,K,L
	.byte M,N,O,P,Q,R,S,T,U,V,W,XX
	.byte YY,Z,One,Two,Three,Four,Five,Six,Seven,Eight,Nine,_
	.byte minus,plus,equal,_,left_parens,right_parens,apostrophe,comma,period,_,_,_
	.byte colon,interrogative,bang,_,_,_,_,_,_,_,_,_








;-------------------------------------------------------------------------
;-------------------------End Data----------------------------------------
;-------------------------------------------------------------------------


	org $FFFC
	.word Start
	.word Start

